Emotional = LibStub("AceAddon-3.0"):NewAddon("Emotional", "AceConsole-3.0", "AceEvent-3.0")

local defaults = {
    char = {
		emote = "gloat",
		enableInParty = true,
		enableInRaid = true
		}
	}

local options = {
    name = "Emotional",
    handler = Emotional,
    type = 'group',
    args = {
		set = {
			type = "input",
			name = "Set Emotion",
			get = "GetEmote",
			set = "SetEmote",
		},
		enableInParty = {
			type = "toggle",
			name = "Enable in Party",
			desc = "Enable/Disable in 5man Groups",
			get = "IsEnableInParty",
			set = "ToggleEnableInParty",
		},
		enableInRaid = {
			type = "toggle",
			name = "Enable in Raid",
			desc = "Enable/Disable in Raid Groups",
			get = "IsEnableInRaid",
			set = "ToggleEnableInRaid",		
		},
    },
}

function Emotional:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("EmotionalDB", defaults)
	
    LibStub("AceConfig-3.0"):RegisterOptionsTable("Emotional", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Emotional", "Emotional")
	self:RegisterChatCommand("emo", "ChatCommand")
	self:RegisterChatCommand("emotional", "ChatCommand")
end

function Emotional:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStuf("AceConfigCmd-3.0"):HandleCommand("emo", "Emotional", input)
	end
end

function Emotional:OnEnable()
	self:Print("v2.0 Loaded")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","Action")
end

function Emotional:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function Emotional:Action(...)
	local arg0, arg1, event, arg3, arg4, caster, arg6, arg7, arg8, target, arg10, arg11, arg12, arg13 = select(1, ...);
	if (event == "UNIT_DIED") and (UnitPlayerControlled(target)) and (UnitIsDeadOrGhost(target)) then
		DoEmote(self.db.char.emote,target)
	end
end

function Emotional:GetEmote(info)
	return self.db.char.emote
end

function Emotional:SetEmote(info, newValue)
	self.db.char.emote = newValue
end

function Emotional:IsEnableInParty(info)
	return self.db.char.enableInParty
end

function Emotional:ToggleEnableInParty(info, newValue)
	self.db.char.enableInParty = newValue
end

function Emotional:IsEnableInRaid(info)
	return self.db.char.enableInRaid
end

function Emotional:ToggleEnableInRaid(info, newValue)
	self.db.char.enableInRaid = newValue
end